aboutsummaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
Diffstat (limited to '')
-rw-r--r--tools/ChangeLog4
-rwxr-xr-xtools/gpgsm-gencert.sh115
2 files changed, 119 insertions, 0 deletions
diff --git a/tools/ChangeLog b/tools/ChangeLog
index e4862bc38..841fb0c98 100644
--- a/tools/ChangeLog
+++ b/tools/ChangeLog
@@ -1,3 +1,7 @@
+2004-08-09 Moritz Schulte <[email protected]>
+
+ * gpgsm-gencert.sh: New file.
+
2004-06-16 Werner Koch <[email protected]>
* rfc822parse.c (rfc822parse_get_field): Add arg VALUEOFF.
diff --git a/tools/gpgsm-gencert.sh b/tools/gpgsm-gencert.sh
new file mode 100755
index 000000000..3241efd94
--- /dev/null
+++ b/tools/gpgsm-gencert.sh
@@ -0,0 +1,115 @@
+#!/bin/sh
+
+# gpgsm-gencert.c - Generate X.509 certificates through GPGSM.
+# Copyright (C) 2004 g10 Code GmbH
+#
+# This file is part of GnuPG.
+#
+# GnuPG is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# GnuPG is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+# 02111-1307, USA.
+
+set -e
+
+ASSUAN_FP_IN=4
+ASSUAN_FP_OUT=5
+
+ASSUAN_COMMANDS="\
+INPUT FD=$ASSUAN_FP_IN\n\
+OUTPUT FD=$ASSUAN_FP_OUT --armor\n\
+GENKEY\n\
+BYE"
+
+ANSWER=""
+
+query_user()
+{
+ message=$1; shift
+
+ echo "$message"
+ echo -n "> "
+ read answer
+
+ ANSWER=$answer;
+}
+
+query_user_menu()
+{
+ message=$1; shift
+ i=0
+
+ echo "$message"
+ for choice in "$@"; do
+ i=$(expr $i + 1)
+ echo " [$i] $choice"
+ done
+
+ while true; do
+ j=1
+ echo -n "Your selection: "
+ read idx
+
+ while [ $j -lt $i -o $j -eq $i ]; do
+ if [ "$idx" = $j ]; then
+ break
+ fi
+ j=$(expr $j + 1)
+ done
+ if [ $j -lt $i -o $j -eq $i ]; then
+ break
+ fi
+ done
+
+ i=0
+ for choice in "$@"; do
+ i=$(expr $i + 1)
+ if [ $i -eq $idx ]; then
+ ANSWER=$1
+ break;
+ fi
+ shift
+ done
+
+ echo "You selected: $ANSWER"
+}
+
+query_user_menu "Key type" "RSA"
+KEY_TYPE=$ANSWER
+
+query_user_menu "Key length" "1024" "2048"
+KEY_LENGTH=$ANSWER
+
+query_user_menu "Key usage" "sign, encrypt"
+KEY_USAGE=$ANSWER
+
+query_user "Name"
+NAME=$ANSWER
+
+query_user "E-Mail address"
+EMAIL_ADDRESS=$ANSWER
+
+file_parameter=$(mktemp "/tmp/gpgsm.XXXXXX")
+
+cat > "$file_parameter" <<EOF
+Key-Type: $KEY_TYPE
+Key-Length: $KEY_LENGTH
+Key-Usage: $KEY_USAGE
+Name-DN: $NAME
+Name-Email: $EMAIL_ADDRESS
+EOF
+
+echo -e "$ASSUAN_COMMANDS" | gpgsm --server 4< "$file_parameter" 5>&1
+
+rm "$file_parameter"
+exit 0